<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <script>
       /*  Реализовать функцию фильтра массива по указанному типу данных.             
Написать функцию filterBy(), которая будет принимать в себя 2 аргумента. Первый аргумент - массив,
 который будет содержать в себе любые данные, второй аргумент - тип данных.
Функция должна вернуть новый массив, который будет содержать в себе все данные, 
которые были переданы в аргумент, за исключением тех, тип которых был передан вторым аргументом. 
То есть, если передать массив ['hello', 'world', 23, '23', null], и вторым аргументом передать 'string', 
то функция вернет массив [23, null].
*/
let arr=["hello","world",23,"32",45,NaN];
//cоздаю функцию с заданными параметрами(аргументами)
let filterBy=(arr,type)=>{ 
    /*новый массив = старый массив . метод filter(который проходит по всем элементам и 
    отфильтровывает те, которые не проходят по условиям, выводит элемент только если true),
     указываем что будет происходить с каждым элементом: 
     функция,с 1 аргументом => проверяет не равняется ли тип элемента заданному типу
     если выходит string !== string = false - отбрасывает,
                  string !== number = true - включает в новый массив*/
    let newArr=arr.filter(elem => typeof elem !== type);
    document.write(`Новый массив: ${newArr}`);};
/*функция userType - запрашивает ввести тип данных которые будут откидываться,
далее - выполняет функцию(первый аргумент-массив, второй-тип данных ,который ввел пользователь) описанную выше,
*/
let userType=()=>{
    let newType=prompt("Введите тип данных:",);
    filterBy(arr,newType);
};
//выполняется и выводит
userType();
    </script>
</body>
</html>